<?
/*
      +----------------------------------------------------------------------+
      | GUnet eClass 1.7                                                    |
      | Asychronous Teleteaching Platform                                    |
      +----------------------------------------------------------------------+
      | Copyright (c) 2003-2007  GUnet                                       |
      +----------------------------------------------------------------------+
      |                                                                      |
      | GUnet eClass 1.7 is an open platform distributed in the hope that   |
      | it will be useful (without any warranty), under the terms of the     |
      | GNU License (General Public License) as published by the Free        |
      | Software Foundation. The full license can be read in "license.txt".  |
      |                                                                      |
      | Main Developers Group: Costas Tsibanis <k.tsibanis@noc.uoa.gr>       |
      |                        Yannis Exidaridis <jexi@noc.uoa.gr>           |
      |                        Alexandros Diamantidis <adia@noc.uoa.gr>      |
      |                        Tilemachos Raptis <traptis@noc.uoa.gr>        |
      |                                                                      |
      | For a full list of contributors, see "credits.txt".                  |
      |                                                                      |
      +----------------------------------------------------------------------+
      | Contact address: Asynchronous Teleteaching Group (eclass@gunet.gr),  |
      |                  Network Operations Center, University of Athens,    |
      |                  Panepistimiopolis Ilissia, 15784, Athens, Greece    |
      +----------------------------------------------------------------------+
*/

/*
 * You can set the following variables before including this file:
 *
 * $langFiles: a variable or array containing the names of 
 *             language files required (without the .inc.php extension)
 * $require_login: set to true to mark a file that requires a logged-in user
 * $require_current_course: set to true to mark a file requiring
 *             the user to have selected a course. In this case, the
 *             variables containing course settings are given values.
 * $language_override: set this to force messages in another language
 *
 * To show the initial banner, call the function begin_page().
 * The name of the page is taken from the variable $nameTools,
 * and additional navigation breadcrumps are taken from the
 * array $navigation, which must contain pairs of (url, description)
 * like this:
 * $navigation[] = array("url" => "file.php", "name"=> "Description");
 * You can set $page_title to have a title different from $nameTools.
 * You can also call begin_page() as:
 * begin_page($nameTools, $navigation) (both arguments are optional).
 * If you want to add something to the stylesheet set for this page,
 * set the variable $local_style before calling begin_page(); e.g.,
 * $local_style = 'body { background: red; }';
 * If you want to add something else in the <HEAD> section of a page,
 * eg. a script, set $local_head appropriately.
 * $body_onload: javascript to add to body's onload attribute
 */

// ---------------------------------------------------------
// this function draws the logo and the navigation bar
// you must call this function in every script you want the logo to be displayed
// ---------------------------------------------------------

function begin_page ($page_name = FALSE, $page_navi = FALSE) {
	global $is_adminOfCourse, $urlServer, $urlAppend, $bannerPath, $nameTools, $intitule, $siteName,
		$charset, $colorLight, $colorMedium, $colorDark,
		$langUser, $langMyPortfolio, $langHomePage, $langTmima, $langProfessor, $prenom, $nom, $titulaires,
		$code_cours, $currentCourseID, $uid, $navigation,
		$mainInterfaceWidth,$langLogout, $mysqlMainDb, $official_prefix,
		$require_help, $require_login, $require_current_course, $require_left_menu, 
		$language, $langHelp, $helpTopic, $page_title, $local_style, $local_head, $body_onload;

	if (!$page_navi)
			$page_navi = $navigation;

	if (!$page_name)
			$page_name = $nameTools;

	@ header('Content-Type: text/html; charset='. $charset);
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=<?= $charset?>">
	<link rel="stylesheet" href="<?= $urlAppend ?>/template/default.css" type="text/css">
        <link rel="SHORTCUT ICON" href="<?= $urlServer ?>images/favicon.ico">
	<? if (!empty($local_style)) {
		echo "<style type='text/css'>$local_style</style>\n";
	}
	if (!empty($local_head)) {
		echo $local_head;
	} ?>
	<title> 
	<?
	if (isset($intitule)) 
		echo q("$page_name - $intitule - $siteName"); 
	else 
		echo q("$page_name - $siteName"); 
	?>
	</title>
</head>
<body<?= isset($body_onload)? " onload='$body_onload'": '' ?>>
<table bgcolor="white" border="0" align="center" cellpadding="0" cellspacing="0" width="<?= $mainInterfaceWidth ?>">
  <tr>
    <td>
      <table cellpadding="0" border=0 cellspacing="0">
        <tr>
          <td colspan="5" align="right" valign=top width=800 height=90 bgcolor="<?= $colorMedium ?>" style="background-image:url(<? echo $urlAppend,'/',$bannerPath ?>)" class="td_banner">
           <?
        if (isset($_SESSION['uid'])) {
           echo "$langUser: <b>". q("$prenom $nom"). "</b>";
           echo ", <a href='${urlServer}index.php?logout=yes' target=_top class=userbar><b><font color='#DE5E41'>$langLogout</font></b></a>\n";
                } else {
                        echo "&nbsp;\n";
                }
?>
          </td>
        </tr>
<?
//------------------------------
// end of additional info
//-----------------------------

?>
	<tr>
    <td colspan="5" class="td_navbar" style="background-image:url(<? echo $urlAppend,'/','images/bg.gif' ?>)">
	  <a href="<?= $urlServer.'index.php' ?>" target="_top" class=navigbar>
<?
		if (isset($_SESSION['uid']))
					  echo $langMyPortfolio;
				else
						  echo $langHomePage;
?>
</a>
<?	
	if (isset($currentCourseID)) {
		if (preg_match("+$currentCourseID/(index.php)?+", $_SERVER['REQUEST_URI']))
			echo "&nbsp;&gt;&nbsp;<b>". q($intitule) ."</b>\n";
		else
			echo "&nbsp;&gt;&nbsp;<a href=\"".$urlServer.
				"courses/$currentCourseID/index.php\" target=\"_top\" class=navigbar>". q($intitule) . "</a>\n";
		}
	if (isset($page_navi) && is_array($page_navi))
		foreach ($page_navi as $step)
			echo "          &nbsp;&gt;&nbsp;<a target=\"_top\" href=\""
				.$step["url"]."\" class=navigbar>".q($step["name"])."</a>";
	if (isset($page_name)) {
		echo "          &nbsp;&gt;&nbsp;<b>" . q($page_name) . "</b>";
	}
?>	
          <br>
	  </td>
        </tr>
<?
if (isset($currentCourseID)) {
$f = mysql_fetch_array(db_query("SELECT fake_code, faculte, type FROM cours WHERE code='$code_cours'",$mysqlMainDb));
	echo "        <tr>\n";
        echo "          <td colspan=\"5\" class=\"td_CourseNameTitle\">\n";
        echo "          $intitule  <span class='td_CourseCode'>($f[0])</span>\n";
        echo "          </td>\n";
        echo "        </tr>\n";
        echo "        <tr>\n";
        echo "          <td colspan=\"5\" class=\"td_CourseName\">\n";
        echo "          $langProfessor: <b>$titulaires</b> ", 
		"(<a href='${urlServer}modules/contact/'>e-mail</a>)\n";
        echo "          <br>\n";
        echo "          $langTmima: <b>$f[1]</b> <small>(".lesson_type($f[2]).")</small> \n";
        echo "          </td>\n";
        echo "        </tr>\n";


//---------------------------------
// additional info for di - eclass
// dont mess about it...
// it has been used in one special adaptation of the platform
//--------------------------------

// check if lesson is official or seminar

$s=mysql_fetch_array(mysql_query("SELECT faculte FROM cours WHERE code='$currentCourseID'"));
if (isset($official_prefix) and $s[0] == $official_prefix) {
        $semester=mysql_fetch_array(db_query("SELECT semester,theory,lab,pract FROM lessons WHERE code='$f[0]'",$mysqlMainDb));
        echo " <br><font face=\" Arial, Helvetica, sans-serif\" size=\"2\">
                <b>: $semester[0]o</b>
                </font>
                <font face=\" Arial, Helvetica, sans-serif\" color=\"#000066\" size=\"2\">";
                echo "<br><font face=\" Arial, Helvetica, sans-serif\" size=\"2\">";
                if (empty($semester[1])) $semester[1]='-';
                        echo "<b> :</b> $semester[1]";
                if (empty($semester[2])) $semester[2]='-';
                        echo "&nbsp;&nbsp;&nbsp;<b> :</b> $semester[2]";
                if (empty($semester[3])) $semester[3]='-';
                echo "&nbsp;&nbsp;&nbsp;<b> :</b> $semester[3]<br>";
        echo "</font>";
        echo "</td></tr>";
        }
if ($s[0] == 'S') {
        echo "<br><font face=\" Arial, Helvetica, sans-serif\" size=\"2\">";
        $sl=mysql_fetch_array(mysql_query("SELECT suplesson FROM cours WHERE code='$code_cours'"));
        if (!empty($sl[0]))
                echo "<b> : $sl[0]</b></font>";
        }

mysql_select_db($currentCourseID);

}

?>
      </table>
    </td>
  </tr>
<?

	if (!empty($page_title)) {
		$page_name = $page_title;
	}

// display left menu when needed
if (!isset($require_left_menu)) {
	if (!empty($page_name)) {
		echo "<tr><td class=SubSystem_Label>" . q($page_name) . "\n";
	}
} 

// if variable $require_help is true then display help link and the appropriate help topic 
if ($is_adminOfCourse and isset($require_help) and $require_help) {
	echo "&nbsp;<a class=\"lbOn\" href='../help/help.php?topic=$helpTopic&amp;language=$language' 
	onClick=\"window.open('../help/help.php?topic=$helpTopic&amp;language=$language','Help','toolbar=no,location=no,directories=no,status=yes,menubar=no,scrollbars=yes,resizable=yes,width=450,height=550,left='+((screen.width-400)/2)+',top='+((screen.height-450)/2));
	return false; \"><img src='".$urlAppend."/images/help.gif' border=0 title='' align='absbottom'></a>
        </td>
        </tr>";
	} else {
        echo "</td>
        </tr>";
        }
/*
	<script type="text/javascript" src="<?= $urlServer ?>modules/help/prototype.js"></script>
        <script type="text/javascript" src="<?= $urlServer ?>modules/help/lightbox.js"></script>
if ($is_adminOfCourse and isset($require_help) and $require_help) {
        echo "&nbsp;<a class=\"lbOn\" href='../help/help.php?topic=$helpTopic&amp;language=$language'><img src='".$urlServer."images/help.gif' border=0 title='' align='absbottom'></a>
        </td>
        </tr>";
        }
if ($is_adminOfCourse and isset($require_help) and $require_help) {
        $handle1 = fopen("$urlServer/modules/help/help.php?topic=$helpTopic&amp;language=$language/", 'r');
        $info = '';
        while (!feof($handle1)) {
           $info .= fread($handle1, 8192);
        }
        fclose($handle1);

        echo "$info\n";
        echo "
&nbsp;<a href='../help/help.php?topic=$helpTopic&amp;language=$language' onmouseover=\"showPopup('nameOfPopup', event);\" onmouseout=\"hideCurrentPopup();\"><img src='".$urlServer."images/help.gif' border=0 title='' align='absbottom'></a>
        </td>
        </tr>";
        }
*/	

echo "  <tr>\n";
echo "  <td> \n";

} 

// ---------------------------------------------
// end of function begin_page
// ---------------------------------------------


// return the type of the lesson 
function lesson_type ($type)  {

global $langPre, $langPost, $langOther;

switch ($type) {
		case 'pre': 
						$message = $langPre;
						break;
		case 'post':
						$message = $langPost;
						break;
		case 'other':
						$message = $langOther;
						break;
		}
	return $message;
}


function start_toolbar()
{
	echo "   <table align='center' width=96% border='0' cellspacing='0' cellpadding='0'  style=\"border: 1px solid #DCDCDC;\">\n";
        echo "   <tr>\n";
        echo "      <td align=right class='tool_bar' valign=middle height=25>";

}

function end_toolbar()
{
				echo "   </td>\n";
        echo "   </tr>\n";
        echo "   </table>\n\n";
        echo "   </br>\n\n";
}

function start_AdminToolbar()
{
        echo "   <table align='center' width=96% border='0' cellspacing='0' cellpadding='0'  style=\"border: 1px solid #DCDCDC;\">\n";
        echo "   <tr>\n";
        echo "      <td align=right class='tool_bar_Admin' valign=middle height=25>";

}

function end_AdminToolbar()
{
                                echo "   </td>\n";
        echo "   </tr>\n";
        echo "   </table>\n\n";
        echo "   </br>\n\n";
}

?>
