<?
/*
      +----------------------------------------------------------------------+
      | GUnet eClass 1.7                                                    |
      | Asychronous Teleteaching Platform                                    |
      +----------------------------------------------------------------------+
      | Copyright (c) 2003-2007  GUnet                                       |
      +----------------------------------------------------------------------+
      |                                                                      |
      | GUnet eClass 1.7 is an open platform distributed in the hope that   |
      | it will be useful (without any warranty), under the terms of the     |
      | GNU License (General Public License) as published by the Free        |
      | Software Foundation. The full license can be read in "license.txt".  |
      |                                                                      |
      | Main Developers Group: Costas Tsibanis <k.tsibanis@noc.uoa.gr>       |
      |                        Yannis Exidaridis <jexi@noc.uoa.gr>           |
      |                        Alexandros Diamantidis <adia@noc.uoa.gr>      |
      |                        Tilemachos Raptis <traptis@noc.uoa.gr>        |
      |                                                                      |
      | For a full list of contributors, see "credits.txt".                  |
      |                                                                      |
      +----------------------------------------------------------------------+
      | Contact address: Asynchronous Teleteaching Group (eclass@gunet.gr),  |
      |                  Network Operations Center, University of Athens,    |
      |                  Panepistimiopolis Ilissia, 15784, Athens, Greece    |
      +----------------------------------------------------------------------+
*/

/*
     +----------------------------------------------------------------------+
     | General useful functions for eClass                                        |
     +----------------------------------------------------------------------+
*/

// Show query string and then do MySQL query
function db_query2($sql, $db = FALSE)
{
	echo "<hr><pre>$sql</pre><hr>";
	return db_query($sql, $db);									
}

/*
-------------------------------------------------------------------------
 it is better to use the function below instead of the usual mysql_query()
 first argument: the query
 second argument (optional) : the name of the data base
 If error happens just display the error and the code
-----------------------------------------------------------------------
*/
// Debug MySQL queries 
function db_query($sql, $db = FALSE) {
        if ($db) {
                mysql_select_db($db);
                $r = mysql_query($sql);
        } else {
                $r = mysql_query($sql);
        }
        if (mysql_errno()) {
                echo '<hr>' . mysql_errno() . ': ' . mysql_error() .
                        "<br><pre>$sql</pre><hr>";
        }
        return $r;
}


// ----------------------------------------------------------------------
// for safety reasons use the functions below
// ---------------------------------------------------------------------
 

// Quote string for SQL query

function quote($s) {
	return "'".addslashes($s)."'";
}

// Shortcut for htmlspecialchars()
function q($s)
{
	return htmlspecialchars($s);
}

// ------------------------------------------------------
// Other useful functions. We use it in various scripts.
// -----------------------------------------------------


// Translate uid to username
function uid_to_username($uid)
{
	global $mysqlMainDb;

	if ($r = mysql_fetch_row(db_query(
			"SELECT username FROM user WHERE user_id = '$uid'",
					  $mysqlMainDb))) {
		return $r[0];
	} else {
		return FALSE;
	}
}

// Translate uid to real name / surname
function uid_to_name($uid)
{
	global $mysqlMainDb;

	if ($r = mysql_fetch_row(db_query("SELECT CONCAT(nom, ' ', prenom)
						FROM user WHERE user_id = '$uid'", $mysqlMainDb))) {
		return $r[0];
	} else {
		return FALSE;
	}
}

// Translate uid to AM (student number)
function uid_to_am($uid)
{
	global $mysqlMainDb;

	if ($r = mysql_fetch_array(db_query("SELECT am from user
		WHERE user_id = '$uid'", $mysqlMainDb))) {
		return $r[0];
	} else {
		return FALSE;
	}
}


// Find a user's group
// If $required == TRUE, show error if user doesn't belong to group
// else returns FALSE;
function user_group($uid, $required = TRUE)
{
	global $currentCourseID;

	$res = db_query("SELECT team FROM user_group WHERE user = '$uid'",
		$currentCourseID);
	if ($res) {
		$secret = mysql_fetch_row($res);
		return $secret[0];
	} else {
		if ($required) {
			die("Error: user tried to submit group work but doesn't belong in a group!");
		} else {
			return FALSE;
		}
	}
}


// Find secret subdir of group gid
function group_secret($gid)
{
	global $currentCourseID;

	$res = db_query("SELECT secretDirectory FROM student_group WHERE id = '$gid'",
		$currentCourseID);
	if ($res) {
		$secret = mysql_fetch_row($res);
		return $secret[0];
	} else {
		die("Error: group $gid doesn't exist");
	}
}

// -------------------------------------------------------------------
// Often useful function (with so many selection boxes in eClass !!)
// ------------------------------------------------------------------


// Show a selection box.
// $entries: an array of (value => label)
// $name: the name of the selection element
// $default: if it matches one of the values, specifies the default entry
function selection($entries, $name, $default = '')
{
	echo "<select name='$name' class='auth_input'>\n";
	foreach ($entries as $value => $label) {
		if ($value == $default) {
			echo "<option selected value='" . htmlspecialchars($value) . "'>" .
				htmlspecialchars($label) . "</option>\n";
		} else {
			echo "<option value='" . htmlspecialchars($value) . "'>" .
				htmlspecialchars($label) . "</option>\n";
		}
	}
	echo "</select>\n";
}



// --------------------------------------------------------------------------
// The check_admin() function is used in the very first place in all scripts in the admin 
// directory. Just checks that we are really admin users (and not fake!) to proceed...
// ----------------------------------------------------------------------------
function check_admin()
{
        global $uid;
        if (isset($uid)) {
                $res = mysql_query("SELECT * FROM admin WHERE idUser='$uid'");
        }
        if (!isset($uid) or !$res or mysql_num_rows($res) == 0) {
        begin_page();
        echo "&nbsp;</td></tr>
              <tr><td height=316 valign=top align=center><br><br>
              <center><h1>  </h1>
              <p>        .<br>
                 <a href=../index.php> </a> 
                 .</p>
              </center>
             ";
        // footer
        end_page();
        exit();
        }
}


// ------------------------------------------
// function to check if user is a guest user
// ------------------------------------------
function check_guest() {
        global $mysqlMainDb, $uid;
        if (isset($uid)) {
                $res = db_query("SELECT statut FROM user WHERE user_id = '$uid'", $mysqlMainDb);
                $g = mysql_fetch_row($res);

                if ($g[0] == 10) {
                        return true;
                } else {
                        return false;
                }
        }
}

// ---------------------------------------------------------------------
// function to check that we are really a professor (and not fake!). 
// --------------------------------------------------------------------
function check_prof()
{
	global $uid;
	if (isset($uid)) {
		$res = db_query("SELECT statut FROM user WHERE user_id='$uid'");
		$s = mysql_fetch_array($res);
		if ($s['statut'] == 1)
			return true;
		else
			return false;
	}

}

// Convert HTML to plain text

function html2text ($string)
{
    $trans_tbl = get_html_translation_table (HTML_ENTITIES);
    $trans_tbl = array_flip ($trans_tbl);

    $text = preg_replace('/</',' <',$string);
    $text = preg_replace('/>/','> ',$string);
    $desc = html_entity_decode(strip_tags($text));
    $desc = preg_replace('/[\n\r\t]/',' ',$desc);
    $desc = preg_replace('/  /',' ',$desc);

	return $desc;
//    return strtr (strip_tags($string), $trans_tbl);
}


/**
 * handling simple and double apostrofe in order that strings be stored properly in database
 *
 * @author Denes Nagy
 * @param  string variable - the variable to be revised
 */
function domesticate($input) {
  $input = stripslashes($input);
  $input = str_replace("'","''",$input);
  return($input);
}


// ------------------------------------------------------------------------------
//  Below there are some IMAP authenticated functions. They have used in one special adaptation
// of the platform.
// ------------------------------------------------------------------------------

/*
     +----------------------------------------------------------------------+
     | IMAP authentication functions                                        |
     +----------------------------------------------------------------------+
*/

function imap_auth($server, $username, $password)
{
        $auth = FALSE;
        $fp = fsockopen($server, 143, $errno, $errstr, 10);
        if ($fp) {
                fputs ($fp, "A1 LOGIN ".imap_literal($username).
                        " ".imap_literal($password)."\r\n");
                fputs ($fp, "A2 LOGOUT\r\n");
                while (!feof($fp)) {
                        $line = fgets ($fp,200);
                        if (substr($line, 0, 5) == 'A1 OK') {
                                $auth = TRUE;
                        }
                }
                fclose ($fp);
        }
        return $auth;
}

function imap_literal($s)
{
        return "{".strlen($s)."}\r\n$s";
}


// -----------------------------------------------------------------------------------
// checking the mysql version 
// note version_compare() is used for checking the php version but works for mysql too
// ------------------------------------------------------------------------------------

function mysql_version() {

$ver = mysql_get_server_info();
if (version_compare("4.1", $ver) <= 0)
	return true;
else
	return false;
}

// Check for LDAP server entries
function check_ldap_entries()  {
	$ldap_entries = mysql_query("SELECT ldapserver FROM institution WHERE ldapserver <> ''");
	if (mysql_num_rows($ldap_entries) > 0) 
		return true;
	else 
		return false;
}


// check for new announcements
function check_new_announce() {

  global $uid;

  $row = mysql_fetch_array(mysql_query("SELECT * FROM loginout WHERE id_user='$uid' AND action = 'LOGIN' ORDER BY idLog DESC"));
  $lastlogin = $row['when'];
  $sql = "SELECT * FROM annonces,cours_user
                WHERE annonces.code_cours=cours_user.code_cours
                AND cours_user.user_id='$uid' AND annonces.temps >= '$lastlogin'
                ORDER BY temps DESC";
  if (mysql_num_rows(mysql_query($sql)) > 0)
    return TRUE;
  else
    return FALSE;

}

/**
 * @param $text
 * @return $text
 * @author Patrick Cool <patrick.cool@UGent.be>
 * @version June 2004
 * @desc apply parsing to content to parse tex commandos that are seperated by [tex][/tex] to make itreadable for techexplorer plugin.
*/
function parse_tex($textext)
{
        $textext=str_replace("[tex]","<EMBED TYPE='application/x-techexplorer' TEXDATA='",$textext);
        $textext=str_replace("[/tex]","' width='100%'>",$textext);
        return $textext;
}



// --------------------------------------
// Useful functions for creating courses
// -------------------------------------

// Returns the code of a faculty given its name
function find_faculty_by_name($name) {
	$code = mysql_fetch_row(db_query("SELECT code FROM faculte
		WHERE name = '$name'"));
	if (!$code) {
		return FALSE;
	} else {
		return $code[0];
	}
}


// Returns next available code for a new course in faculty with code $fac
function new_code($fac) {
	global $mysqlMainDb;

	mysql_select_db($mysqlMainDb);
	$gencode = mysql_fetch_row(db_query("SELECT code, generator
		FROM faculte WHERE code = '$fac'"));
	do {
		$code = $gencode[0].$gencode[1];
		$gencode[1] += 1;
		db_query("UPDATE $mysqlMainDb.faculte SET generator = '$gencode[1]'
			WHERE code = '$fac'");
	} while (mysql_select_db($code));
	mysql_select_db($mysqlMainDb);

	// Make sure the code returned isn't empty!
	if (empty($code)) {
		die("Course Code is empty!");
	}

	return $code;
}

// due to a bug (?) to php function basename()  our implementation
function my_basename($path) {

	return preg_replace('#^.*/#', '', $path);
	
}


// Create a JavaScript-escaped mailto: link
function mailto($address, $alternative='(e-mail address hidden)')
{
        if (empty($address)) {
                echo '&nbsp;';
        } else {
                $prog = urlenc("var a='" . urlenc(str_replace('@', '&#64;', $address)) .
                      "';document.write('<a href=\"mailto:'+unescape(a)+'\">'+unescape(a)+'</a>');");
                return "<script type='text/javascript'>eval(unescape('" .
                      $prog . "'));</script><noscript>$alternative</noscript>";
        }
}

function urlenc($string)
{
        $out = '';
        for ($i = 0; $i < strlen($string); $i++) {
                $out .= sprintf("%%%02x", ord(substr($string, $i, 1)));
        }
        return $out;
}

?>
