<?php 
/*
      +----------------------------------------------------------------------+
      | GUnet eClass 1.7                                                    |
      | Asychronous Teleteaching Platform                                    |
      +----------------------------------------------------------------------+
      | Copyright (c) 2003-2007  GUnet                                       |
      +----------------------------------------------------------------------+
      |                                                                      |
      | GUnet eClass 1.7 is an open platform distributed in the hope that   |
      | it will be useful (without any warranty), under the terms of the     |
      | GNU License (General Public License) as published by the Free        |
      | Software Foundation. The full license can be read in "license.txt".  |
      |                                                                      |
      | Main Developers Group: Costas Tsibanis <k.tsibanis@noc.uoa.gr>       |
      |                        Yannis Exidaridis <jexi@noc.uoa.gr>           |
      |                        Alexandros Diamantidis <adia@noc.uoa.gr>      |
      |                        Tilemachos Raptis <traptis@noc.uoa.gr>        |
      |                                                                      |
      | For a full list of contributors, see "credits.txt".                  |
      |                                                                      |
      +----------------------------------------------------------------------+
      | Contact address: Asynchronous Teleteaching Group (eclass@gunet.gr),  |
      |                  Network Operations Center, University of Athens,    |
      |                  Panepistimiopolis Ilissia, 15784, Athens, Greece    |
      +----------------------------------------------------------------------+
*/

// ALLOWED_TO_INCLUDE is defined in admin.php
if(!defined('ALLOWED_TO_INCLUDE'))
{
	exit();
}

$questionName=$objQuestion->selectTitle();
$answerType=$objQuestion->selectType();

$okPicture=file_exists($picturePath.'/quiz-'.$questionId)?true:false;

// if we come from the warning box "this question is used in serveral exercises"
if(isset($modifyIn))
{
	// if the user has chosed to modify the question only in the current exercise
	if($modifyIn == 'thisExercise')
	{
		// duplicates the question
		$questionId=$objQuestion->duplicate();

		// deletes the old question
		$objQuestion->delete($exerciseId);

		// removes the old question ID from the question list of the Exercise object
		$objExercise->removeFromList($modifyAnswers);

		// adds the new question ID into the question list of the Exercise object
		$objExercise->addToList($questionId);

		// construction of the duplicated Question
		$objQuestion=new Question();

		$objQuestion->read($questionId);

		// adds the exercise ID into the exercise list of the Question object
		$objQuestion->addToList($exerciseId);

		// copies answers from $modifyAnswers to $questionId
		$objAnswer->duplicate($questionId);

		// construction of the duplicated Answers
		$objAnswer=new Answer($questionId);
	}

	if($answerType == UNIQUE_ANSWER || $answerType == MULTIPLE_ANSWER)
	{
		$correct=unserialize($correct);
		$reponse=unserialize($reponse);
		$comment=unserialize($comment);
		$weighting=unserialize($weighting);
	}
	elseif($answerType == MATCHING)
	{
		$option=unserialize($option);
		$match=unserialize($match);
		$sel=unserialize($sel);
		$weighting=unserialize($weighting);
	}
	else
	{
		$reponse=unserialize($reponse);
		$comment=unserialize($comment);
		$blanks=unserialize($blanks);
		$weighting=unserialize($weighting);
	}

	unset($buttonBack);
}

// the answer form has been submitted
if(isset($submitAnswers) || isset($buttonBack))
{
	if($answerType == UNIQUE_ANSWER || $answerType == MULTIPLE_ANSWER)
	{
		$questionWeighting=$nbrGoodAnswers=0;

		for($i=1;$i <= $nbrAnswers;$i++)
		{
			$reponse[$i]=trim($reponse[$i]);
			$comment[$i]=trim($comment[$i]);
			$weighting[$i]=intval($weighting[$i]);

			if($answerType == UNIQUE_ANSWER)
			{
				$goodAnswer=($correct == $i)?1:0;
			}
			else
			{
				$goodAnswer=@$correct[$i];
			}

			if($goodAnswer)
			{
				$nbrGoodAnswers++;

				// a good answer can't have a negative weighting
				$weighting[$i]=abs($weighting[$i]);

				// calculates the sum of answer weighting only if it is different from 0 and the answer is good
				if($weighting[$i])
				{
					$questionWeighting+=$weighting[$i];
				}
			}
			else
			{
				// a bad answer can't have a positive weighting
				$weighting[$i]=0-abs($weighting[$i]);
			}

			// checks if field is empty
			if(empty($reponse[$i]))
			{
				$msgErr=$langGiveAnswers;

				// clears answers already recorded into the Answer object
				$objAnswer->cancel();

				break;
			}
			else
			{
				// adds the answer into the object
				$objAnswer->createAnswer($reponse[$i],$goodAnswer,$comment[$i],$weighting[$i],$i);
			}
		}  // end for()

		if(empty($msgErr))
		{
			if(!$nbrGoodAnswers)
			{
				$msgErr=($answerType == UNIQUE_ANSWER)?$langChooseGoodAnswer:$langChooseGoodAnswers;

				// clears answers already recorded into the Answer object
				$objAnswer->cancel();
			}
			// checks if the question is used in several exercises
			elseif($exerciseId && !isset($modifyIn) && $objQuestion->selectNbrExercises() > 1)
			{
				$usedInSeveralExercises=1;
			}
			else
			{
				// saves the answers into the data base
				$objAnswer->save();

				// sets the total weighting of the question
				$objQuestion->updateWeighting($questionWeighting);
				$objQuestion->save($exerciseId);

				$editQuestion=$questionId;

				unset($modifyAnswers);
			}
		}
	}
	elseif($answerType == FILL_IN_BLANKS)
	{
		$reponse=trim($reponse);

		if(!isset($buttonBack))
		{
			if($setWeighting)
			{
				@$blanks=unserialize($blanks);

				// checks if the question is used in several exercises
				if($exerciseId && !isset($modifyIn) && $objQuestion->selectNbrExercises() > 1)
				{
					$usedInSeveralExercises=1;
				}
				else
				{
					// separates text and weightings by '::'
					$reponse.='::';

					$questionWeighting=0;

					foreach($weighting as $val)
					{
						// a blank can't have a negative weighting
						$val=abs($val);

						$questionWeighting+=$val;

						// adds blank weighting at the end of the text
						$reponse.=$val.',';
					}

					$reponse=substr($reponse,0,-1);

					$objAnswer->createAnswer($reponse,0,'',0,'');
					$objAnswer->save();

					// sets the total weighting of the question
					$objQuestion->updateWeighting($questionWeighting);
					$objQuestion->save($exerciseId);

					$editQuestion=$questionId;

					unset($modifyAnswers);
				}
			}
			// if no text has been typed or the text contains no blank
			elseif(empty($reponse))
			{
				$msgErr=$langGiveText;
			}
			elseif(!ereg('\[.+\]',$reponse))
			{
				$msgErr=$langDefineBlanks;
			}
			else
			{
				// now we're going to give a weighting to each blank
				$setWeighting=1;

				unset($submitAnswers);

				// removes character '::' possibly inserted by the user in the text
				$reponse=str_replace('::','',$reponse);

				// we save the answer because it will be modified
				$temp=$reponse;

				// blanks will be put into an array
				$blanks=Array();

				$i=1;

				// the loop will stop at the end of the text
				while(1)
				{
					// quits the loop if there are no more blanks
					if(($pos = strpos($temp,'[')) === false)
					{
						break;
					}

					// removes characters till '['
					$temp=substr($temp,$pos+1);

					// quits the loop if there are no more blanks
					if(($pos = strpos($temp,']')) === false)
					{
						break;
					}

					// stores the found blank into the array
					$blanks[$i++]=substr($temp,0,$pos);

					// removes the character ']'
					$temp=substr($temp,$pos+1);
				}
			}
		}
		else
		{
			unset($setWeighting);
		}
	}
	elseif($answerType == MATCHING)
	{
		for($i=1;$i <= $nbrOptions;$i++)
		{
			$option[$i]=trim($option[$i]);

			// checks if field is empty
			if(empty($option[$i]))
			{
				$msgErr=$langFillLists;

				// clears options already recorded into the Answer object
				$objAnswer->cancel();

				break;
			}
			else
			{
				// adds the option into the object
				$objAnswer->createAnswer($option[$i],0,'',0,$i);
			}
		}

		$questionWeighting=0;

		if(empty($msgErr))
		{
			for($j=1;$j <= $nbrMatches;$i++,$j++)
			{
				$match[$i]=trim($match[$i]);
				$weighting[$i]=abs(intval($weighting[$i]));

				$questionWeighting+=$weighting[$i];

				// checks if field is empty
				if(empty($match[$i]))
				{
					$msgErr=$langFillLists;

					// clears matches already recorded into the Answer object
					$objAnswer->cancel();

					break;
				}
				// check if correct number
				else
				{
					// adds the answer into the object
					$objAnswer->createAnswer($match[$i],$sel[$i],'',$weighting[$i],$i);
				}
			}
		}

		if(empty($msgErr))
		{
			// checks if the question is used in several exercises
			if($exerciseId && !isset($modifyIn) && $objQuestion->selectNbrExercises() > 1)
			{
				$usedInSeveralExercises=1;
			}
			else
			{
				// all answers have been recorded, so we save them into the data base
				$objAnswer->save();

				// sets the total weighting of the question
				$objQuestion->updateWeighting($questionWeighting);
				$objQuestion->save($exerciseId);

				$editQuestion=$questionId;

				unset($modifyAnswers);
			}
		}
	}
}

if(isset($modifyAnswers))
{
	// construction of the Answer object
	$objAnswer=new Answer($questionId);

	session_register('objAnswer');

	if($answerType == UNIQUE_ANSWER || $answerType == MULTIPLE_ANSWER)
	{
		if(!isset($nbrAnswers))
		{
			$nbrAnswers=$objAnswer->selectNbrAnswers();

			$reponse=Array();
			$comment=Array();
			$weighting=Array();

			// initializing
			if($answerType == MULTIPLE_ANSWER)
			{
				$correct=Array();
			}
			else
			{
				$correct=0;
			}

			for($i=1;$i <= $nbrAnswers;$i++)
			{
				$reponse[$i]=$objAnswer->selectAnswer($i);
				$comment[$i]=$objAnswer->selectComment($i);
				$weighting[$i]=$objAnswer->selectWeighting($i);

				if($answerType == MULTIPLE_ANSWER)
				{
					$correct[$i]=$objAnswer->isCorrect($i);
				}
				elseif($objAnswer->isCorrect($i))
				{
					$correct=$i;
				}
			}
		}

		if(isset($lessAnswers))
		{
			$nbrAnswers--;
		}

		if(isset($moreAnswers))
		{
			$nbrAnswers++;
		}

		// minimum 2 answers
		if($nbrAnswers < 2)
		{
			$nbrAnswers=2;
		}
	}
	elseif($answerType == FILL_IN_BLANKS)
	{
		if(!isset($submitAnswers) && !isset($buttonBack))
		{
			if(!isset($setWeighting))
			{
				$reponse=$objAnswer->selectAnswer(1);

				@list($reponse,$weighting)=explode('::',$reponse);

				$weighting=explode(',',$weighting);

				$temp=Array();

				// keys of the array go from 1 to N and not from 0 to N-1
				for($i=0;$i < sizeof($weighting);$i++)
				{
					$temp[$i+1]=$weighting[$i];
				}

				$weighting=$temp;
			}
			elseif(!@$modifyIn)
			{
				$weighting=unserialize($weighting);
			}
		}
	}
	elseif($answerType == MATCHING)
	{
		if(!isset($nbrOptions) || !isset($nbrMatches))
		{
			$option=Array();
			$match=Array();
			$sel=Array();

			$nbrOptions=$nbrMatches=0;

			// fills arrays with data from de data base
			for($i=1;$i <= $objAnswer->selectNbrAnswers();$i++)
			{
				// it is a match
				if($objAnswer->isCorrect($i))
				{
					$match[$i]=$objAnswer->selectAnswer($i);
					$sel[$i]=$objAnswer->isCorrect($i);
					$weighting[$i]=$objAnswer->selectWeighting($i);
					$nbrMatches++;
				}
				// it is an option
				else
				{
					$option[$i]=$objAnswer->selectAnswer($i);
					$nbrOptions++;
				}
			}
		}

		if(isset($lessOptions))
		{
			// keeps the correct sequence of array keys when removing an option from the list
			for($i=$nbrOptions+1,$j=1;$nbrOptions > 2 && $j <= $nbrMatches;$i++,$j++)
			{
				$match[$i-1]=$match[$i];
				$sel[$i-1]=$sel[$i];
				$weighting[$i-1]=$weighting[$i];
			}

			unset($match[$i-1]);
			unset($sel[$i-1]);

			$nbrOptions--;
		}

		if(isset($moreOptions))
		{
			// keeps the correct sequence of array keys when adding an option into the list
			for($i=$nbrMatches+$nbrOptions;$i > $nbrOptions;$i--)
			{
				$match[$i+1]=$match[$i];
				$sel[$i+1]=$sel[$i];
				$weighting[$i+1]=$weighting[$i];
			}

			unset($match[$i+1]);
			unset($sel[$i+1]);

			$nbrOptions++;
		}

		if(isset($lessMatches))
		{
			$nbrMatches--;
		}

		if(isset($moreMatches))
		{
			$nbrMatches++;
		}

		// minimum 2 options
		if($nbrOptions < 2)
		{
			$nbrOptions=2;
		}

		// minimum 2 matches
		if($nbrMatches < 2)
		{
			$nbrMatches=2;
		}

	}

	if(!isset($usedInSeveralExercises))
	{
		if($answerType == UNIQUE_ANSWER || $answerType == MULTIPLE_ANSWER)
		{
?>



<table align="center" width="96%"  border='0' cellspacing='0' cellpadding='0'  style="border: 1px solid <? echo "$table_border"; ?>;">

<tr>
   <td valign=middle class=td_QuestionHeader align=left>
   <b><?= $langQuestion ?>:</b>
   </td>
</tr>
<tr>
   <td class=td_QuestionHeader valign=middle>
        <?= $questionName ?>
   </td>
</tr>
<tr>
   <td valign=middle class='td_QuestionBody'>


<form method="post" action="<?php echo $PHP_SELF; ?>?modifyAnswers=<?php echo $modifyAnswers; ?>">
<input type="hidden" name="formSent" value="1">
<input type="hidden" name="nbrAnswers" value="<?php echo $nbrAnswers; ?>">
<table width="96%" border="0" align='center' bordercolor='silver' style='border: thin;' cellspacing="0" cellpadding="0">
<tr>
  <td colspan="5">&nbsp;</td>
</tr>


<?php
			if($okPicture)
			{
?>

<tr>
  <td colspan="5" align="center"><img src="<?php echo $picturePath.'/quiz-'.$questionId; ?>" border="0"></td>
</tr>

<?php
			}

			// if there is an error message
			if(!empty($msgErr))
			{
?>

<tr>
  <td colspan="5" style="border: 1px solid <? echo "$table_border"; ?>;">
	<table border="0" cellpadding="4" cellspacing=0 align="center" width="100%" bgcolor="#FFCC00">
	<tr>
	  <td><?php echo $msgErr; ?></td>
	</tr>
	</table>
  </td>
</tr>

<?php
			}
?>

<tr>
  <td colspan="5" class=td_QuestionBody><b><?php echo $langAnswers; ?> :</b></td>
</tr>
<tr >
  <td align='center' valign=middle height=25 style="border: 1px solid grey;">N</td>
  <td align='center' style="border: 1px solid grey;"><?php echo $langTrue; ?></td>
  <td align='center' style="border: 1px solid grey;"><?php echo $langAnswer; ?></td>
  <td align='center' style="border: 1px solid grey;"><?php echo $langComment; ?></td>
  <td align='center' style="border: 1px solid grey;"><?php echo $langQuestionWeighting; ?></td>
</tr>

<?php
			for($i=1;$i <= $nbrAnswers;$i++)
			{
?>

<tr>
  <td valign="top" align='right'><?php echo $i; ?>.</td>

<?php
				if($answerType == UNIQUE_ANSWER)
				{
?>

  <td valign="top" align=center><input type="radio" value="<?= $i; ?>" name="correct" <?php if(isset($correct) and $correct == $i) echo 'checked="checked"'; ?>></td>

<?php
				}
				else
				{
?>

<td valign="top"><input type="checkbox" value="1" name="correct[<?= $i; ?>]" <?php if(isset($correct[$i])) echo 'checked="checked"'; ?>></td>

<?php
				}
?>

  <td align="center"><textarea class="auth_input" wrap="virtual" rows="7" cols="25" name="reponse[<?= $i; ?>]"><?php echo @htmlspecialchars($reponse[$i]); ?></textarea></td>
  <td align="center"><textarea class="auth_input" wrap="virtual" rows="7" cols="25" name="comment[<?= $i; ?>]"><?php echo @htmlspecialchars($comment[$i]); ?></textarea></td>
  <td valign="top" align="center"><input class="auth_input" type="text" name="weighting[<?php echo $i; ?>]" size="5" value="<?php echo isset($weighting[$i])?$weighting[$i]:0; ?>"></td>
</tr>

<?php
  			}
?>

<tr>
  <td colspan="5" align="center">
  	<input type="submit" class='buttonSubmit' name="submitAnswers" value="<?php echo $langOk; ?>">&nbsp;&nbsp;
	<input type="submit" class='buttonSubmit' name="lessAnswers" value="<?php echo $langLessAnswers; ?>">&nbsp;&nbsp;
	<input type="submit" class='buttonSubmit' name="moreAnswers" value="<?php echo $langMoreAnswers; ?>">&nbsp;&nbsp;
	<input type="submit" class='buttonSubmit' name="cancelAnswers" value="<?php echo $langCancel; ?>">&nbsp;&nbsp;
  </td>
</tr>
</table>
</form>

   </td>
</tr>
</table>


<?php
		}
		elseif($answerType == FILL_IN_BLANKS)
		{
?>

<table align="center" width="96%"  border='0' cellspacing='0' cellpadding='0' style="border: 1px solid <? echo "$table_border"; ?>;">

<tr>
   <td valign=middle class=td_QuestionHeader align=left>
   <b><?= $langQuestion ?>:</b>
   </td>
</tr>
<tr>
   <td class=td_QuestionHeader valign=middle>
	<?php echo $questionName; ?>
   </td>
</tr>
<tr>
   <td class=td_QuestionBody valign=middle>
   

<form name="formulaire" method="post" action="<?= $_SERVER['PHP_SELF'] ?>?modifyAnswers=<?= $modifyAnswers ?>">
<input type="hidden" name="formSent" value="1">
<input type="hidden" name="setWeighting" value="<?= @$setWeighting ?>">

<?php
			if(!isset($setWeighting))
			{
?>

<input type="hidden" name="weighting" value="<?php (@$submitAnswers)?htmlspecialchars($weighting):htmlspecialchars(serialize($weighting)); ?>">

<table border="0" cellpadding="3" width="100%" align=center>

<?
				if($okPicture)
				{
?>

<tr>
  <td align="center"><img src="<?php echo $picturePath.'/quiz-'.$questionId; ?>" border="0"></td>
</tr>

<?php
				}

				// if there is an error message
				if(!empty($msgErr))
				{
?>

<tr>
  <td style="border: 1px solid <? echo "$table_border"; ?>;">
	<table border="0" cellpadding="3" align="center" width="400" bgcolor="#FFCC00">
	<tr>
	  <td><?= $msgErr ?></td>
	</tr>
	</table>
  </td>
</tr>

<?
				}
?>

<tr>
  <td><?php echo $langTypeTextBelow.', '.$langAnd.' '.$langUseTagForBlank; ?> :</td>
</tr>
<tr>
  <td align=center><textarea class=auth_input wrap="virtual" name="reponse" cols="65" rows="6"><?php if(!isset($submitAnswers) && empty($reponse)) echo $langDefaultTextInBlanks; else echo htmlspecialchars($reponse); ?></textarea></td>
</tr>
<tr>
  <td colspan="5" align="center">
	<input type="submit" class=buttonSubmit name="submitAnswers" value="<?= $langNext; ?> &gt;">
	&nbsp;&nbsp;<input type="submit" class=buttonSubmit name="cancelAnswers" value="<?= $langCancel ?>">
  </td>
</tr>
</table>

<?php
			}
			else
			{
?>

<input type="hidden" name="blanks" value="<? echo htmlspecialchars(serialize($blanks)); ?>">
<input type="hidden" name="reponse" value="<? echo htmlspecialchars($reponse); ?>">

<table border="0" cellpadding="5" width="500">

<?php
				// if there is an error message
				if(!empty($msgErr))
				{
?>

<tr>
  <td colspan="2" style="border: 1px solid <? echo "$table_border"; ?>;">
	<table border="0" cellpadding="3" align="center" width="400" bgcolor="#FFCC00">
	<tr>
	  <td><?= $msgErr ?></td>
	</tr>
	</table>
  </td>
</tr>

<?
				}
?>

<tr>
  <td colspan="2"><?= $langWeightingForEachBlank; ?> :</td>
</tr>
<tr>
  <td colspan="2">&nbsp;</td>
</tr>

<?
				foreach($blanks as $i=>$blank)
				{
?>

<tr>
  <td width="50%"><?= $blank ?> :</td>
  <td width="50%"><input type="text" name="weighting[<?php echo $i; ?>]" size="5" value="<?php echo intval($weighting[$i]); ?>"></td>
</tr>

<?
	    		}
?>

<tr>
  <td colspan="2">&nbsp;</td>
</tr>
<tr>
  <td colspan="2" align="center">
	<input type="submit" name="buttonBack" value="&lt; <?= $langBack ?>">
	&nbsp;&nbsp;<input type="submit" name="submitAnswers" value="<?= $langOk ?>">
	&nbsp;&nbsp;<input type="submit" name="cancelAnswers" value="<?= $langCancel ?>">
 </td>
</tr>
</table>
</form>

<?
			}
?>
   </td>
</tr>
</table>

<?
		}
		elseif($answerType == MATCHING)
		{
?>

<table align="center" width="96%"  border='0' cellspacing='0' cellpadding='0' style="border: 1px solid <? echo "$table_border"; ?>;">

<tr>
   <td valign=middle class=td_QuestionHeader align=left>
   <b><?= $langQuestion ?>:</b>
   </td>
</tr>
<tr>
   <td class=td_QuestionHeader valign=middle>
        <?= $questionName ?>
   </td>
</tr>
<tr>
   <td valign=middle class=td_QuestionBody>


<form method="post" action="<?= $_SERVER['PHP_SELF'] ?>?modifyAnswers=<?= $modifyAnswers ?>">
<input type="hidden" name="formSent" value="1">
<input type="hidden" name="nbrOptions" value="<?= $nbrOptions ?>">
<input type="hidden" name="nbrMatches" value="<?= $nbrMatches ?>">
<table border="0" cellpadding="5" cellspacing=2   width="96%" align=center >
<tr>
   <td>&nbsp;</td>
</tr>

<?
		if($okPicture)
			{
?>

<tr>
  <td colspan="4" align="center"><img src="<? echo $picturePath.'/quiz-'.$questionId; ?>" border="0"></td>
</tr>

<?
			}

			// if there is an error message
			if(!empty($msgErr))
			{
?>

<tr>
  <td colspan="4" style="border: 1px solid <? echo "$table_border"; ?>;">
	<table border="0" cellpadding="3" cellspacing=0 align="center" width="100%" bgcolor="#FFCC00">
	<tr>
	  <td><?= $msgErr ?></td>
	</tr>
	</table>
  </td>
</tr>

<?
			}

			$listeOptions=Array();

			// creates an array with the option letters
			for($i=1,$j='A';$i <= $nbrOptions;$i++,$j++)
			{
				$listeOptions[$i]=$j;
			}
?>

<tr>
  <td colspan="3" class=e><?php echo $langMakeCorrespond; ?> :</td>
  <td class=e><?php echo $langQuestionWeighting; ?> :</td>
</tr>

<?
			for($j=1;$j <= $nbrMatches;$i++,$j++)
			{
?>

<tr>
  <td align=right><?= $j; ?>.</td>
  <td><input type="text" name="match[<?= $i; ?>]" size="58" class=auth_input value="<?php if(!isset($formSent) && !isset($match[$i])) echo ${"langDefaultMakeCorrespond$j"}; else echo @htmlspecialchars($match[$i]); ?>"></td>
  <td align="center"><select name="sel[<?= $i; ?>]" class=auth_input>

<?
				foreach($listeOptions as $key=>$val)
				{
?>

<option value="<?= $key; ?>" <?php if((!isset($submitAnswers) && !isset($sel[$i]) && $j == 2 && $val == 'B') || @$sel[$i] == $key) echo 'selected="selected"'; ?>><?= $val; ?></option>

<?
				} // end foreach()
?>

  </select></td>
  <td align="center"><input type="text" size="8" class=auth_input name="weighting[<?= $i ?>]" value="<?php if(!isset($submitAnswers) && !isset($weighting[$i])) echo '5'; else echo $weighting[$i]; ?>"></td>
</tr>

<?
		  	} // end for()
?>

<tr>
  <td colspan="4">
	<input type="submit" name="moreMatches" class=buttonSubmit value="<?= $langMoreElements ?>">
	&nbsp;&nbsp;<input type="submit" class=buttonSubmit name="lessMatches" value="<?= $langLessElements ?>">
  </td>
</tr>
<tr>
  <td colspan="4" class=e><?php echo $langDefineOptions; ?> :</td>
</tr>

<?php
			foreach($listeOptions as $key=>$val)
			{
?>

<tr>
  <td align=right><?php echo $val; ?>.</td>
  <td colspan="3"><input type="text" class=auth_input name="option[<?= $key; ?>]" size="80" value="<?php if(!isset($formSent) && !isset($option[$key])) echo ${"langDefaultMatchingOpt$val"}; else echo @htmlspecialchars($option[$key]); ?>"></td>
</tr>

<?
			 } // end foreach()
?>

<tr>
  <td colspan="4">
	<input type="submit" name="moreOptions" class=buttonSubmit value="<?= $langMoreElements ?>">
	&nbsp;&nbsp;<input type="submit" name="lessOptions" class=buttonSubmit value="<?= $langLessElements ?>">
  </td>
</tr>
<tr>
  <td colspan="4" align="center">
  	<input type="submit" name="submitAnswers" class=buttonSubmit value="<?= $langOk ?>">
	&nbsp;&nbsp;<input type="submit" class=buttonSubmit name="cancelAnswers" value="<?= $langCancel ?>">
	
  </td>
</tr>
</table>
</form>
  </td>
</tr>
</table>
<?
		}
	}
}
echo "<br>";
?>
