<?php 
/*
      +----------------------------------------------------------------------+
      | GUnet eClass 1.7                                                    |
      | Asychronous Teleteaching Platform                                    |
      +----------------------------------------------------------------------+
      | Copyright (c) 2003-2007  GUnet                                       |
      +----------------------------------------------------------------------+
      |                                                                      |
      | GUnet eClass 1.7 is an open platform distributed in the hope that   |
      | it will be useful (without any warranty), under the terms of the     |
      | GNU License (General Public License) as published by the Free        |
      | Software Foundation. The full license can be read in "license.txt".  |
      |                                                                      |
      | Main Developers Group: Costas Tsibanis <k.tsibanis@noc.uoa.gr>       |
      |                        Yannis Exidaridis <jexi@noc.uoa.gr>           |
      |                        Alexandros Diamantidis <adia@noc.uoa.gr>      |
      |                        Tilemachos Raptis <traptis@noc.uoa.gr>        |
      |                                                                      |
      | For a full list of contributors, see "credits.txt".                  |
      |                                                                      |
      +----------------------------------------------------------------------+
      | Contact address: Asynchronous Teleteaching Group (eclass@gunet.gr),  |
      |                  Network Operations Center, University of Athens,    |
      |                  Panepistimiopolis Ilissia, 15784, Athens, Greece    |
      +----------------------------------------------------------------------+
*/

/**
 * This script allows to run an exercise. According to the exercise type, questions
 * can be on an unique page, or one per page with a Next button.
 *
 * One exercise may contain different types of answers (unique or multiple selection,
 * matching and fill in blanks).
 *
 * Questions are selected randomly or not.
 *
 * When the user has answered all questions and clicks on the button "Ok",
 * it goes to exercise_result.php
 *
 * Notice : This script is also used to show a question before modifying it by
 * the administrator
 */

include('exercise.class.php');
include('question.class.php');
include('answer.class.php');

include('exercise.lib.php');
 
// answer types
define('UNIQUE_ANSWER',1);
define('MULTIPLE_ANSWER',2);
define('FILL_IN_BLANKS',3);
define('MATCHING',4);

$require_current_course = TRUE;
$langFiles='exercice';
$require_help = TRUE;
$helpTopic = 'Exercise';

include('../../include/init.php');

$nameTools = $langExercice;

include('../../include/lib/textLib.inc.php');

$picturePath='../../courses/'.$currentCourseID.'/image';

$is_allowedToEdit=$is_adminOfCourse;
$dbNameGlu=$currentCourseID;

$TBL_EXERCICE_QUESTION='exercice_question';
$TBL_EXERCICES='exercices';
$TBL_QUESTIONS='questions';
$TBL_REPONSES='reponses';

// if the user has clicked on the "Cancel" button
if(isset($buttonCancel)) {
	// returns to the exercise list
	header('Location: exercice.php');
	exit();
}



// if the user has submitted the form
if(isset($formSent)) {
	// initializing
	if(!is_array(@$exerciseResult)) {
		$exerciseResult=array();
	}

	// if the user has answered at least one question
	if(@is_array($choice))
	{
		if($exerciseType == 1)
		{
			// $exerciseResult receives the content of the form.
			// Each choice of the student is stored into the array $choice
			$exerciseResult=$choice;
		}
		else
		{
			// gets the question ID from $choice. It is the key of the array
			list($key)=array_keys($choice);

			// if the user didn't already answer this question
			if(!isset($exerciseResult[$key]))
			{
				// stores the user answer into the array
				$exerciseResult[$key]=$choice[$key];
			}
		}
	}

	// the script "exercise_result.php" will take the variable $exerciseResult from the session
	session_register('exerciseResult');

	// if it is the last question (only for a sequential exercise)
	if($exerciseType == 1 || $questionNum >= $nbrQuestions) {
		// goes to the script that will show the result of the exercise
		header('Location: exercise_result.php');
		exit();
	}
}

$navigation[]=array("url" => "exercice.php","name" => $langExercices);
begin_page($nameTools);

echo "<table align=center height=316 width=100% border=\"0\" cellpadding=\"0\" cellspacing=\"0\">\n";
echo "<tr>\n";
echo "<td valign=top>\n";

// if the object is not in the session
if(!session_is_registered('objExercise')) {
	// construction of Exercise
	$objExercise=new Exercise();

	// if the specified exercise doesn't exist or is disabled
	//if(!$objExercise->read($exerciseId) || (!$objExercise->selectStatus() && !$is_allowedToEdit))
	if(!$objExercise->read($exerciseId) && (!$is_allowedToEdit))
		{
		die($langExerciseNotFound);
	}

	// saves the object into the session
	session_register('objExercise');
}

$exerciseTitle=$objExercise->selectTitle();
$exerciseDescription=$objExercise->selectDescription();
$randomQuestions=$objExercise->isRandom();
$exerciseType=$objExercise->selectType();

if(!session_is_registered('questionList')) {
	// selects the list of question ID
	$questionList=$randomQuestions?$objExercise->selectRandomList():$objExercise->selectQuestionList();

	// saves the question list into the session
	session_register('questionList');
}

$nbrQuestions=sizeof($questionList);

// if questionNum comes from POST and not from GET
if(!isset($questionNum) || $_POST['questionNum']) {
	// only used for sequential exercises (see $exerciseType)
	if(!isset($questionNum)) {
		$questionNum=1;
	} else {
		$questionNum++;
	}
}



if(@$_POST['questionNum']) {
	$QUERY_STRING="questionNum=$questionNum";
}

?>
   <table border="0" align='center' width="96%" style="border: 1px solid <? echo "$table_border"; ?>;" cellspacing=\"0\" cellpadding=\"0\">
   <tr>
      <td class=td_QuestionHeader><b><?= $exerciseTitle; ?></b>:&nbsp;&nbsp;<?php echo nl2br(make_clickable($exerciseDescription)); ?></td>
   </tr>
   </table>
   <br>

   
   <form method="post" action="<?= $_SERVER['PHP_SELF']; ?>" autocomplete="off">
   <input type="hidden" name="formSent" value="1">
   <input type="hidden" name="exerciseType" value="<?= $exerciseType; ?>">
   <input type="hidden" name="questionNum" value="<?= $questionNum; ?>">
   <input type="hidden" name="nbrQuestions" value="<?= $nbrQuestions; ?>">
<?

$i=0;
foreach($questionList as $questionId) {
	$i++;

	// for sequential exercises
	if($exerciseType == 2)
	{
	//echo "<table width=\"100%\" cellpadding=\"0\" cellspacing=\"0\" border=\"0\">\n";
		// if it is not the right question, goes to the next loop iteration
		if($questionNum != $i)
		{
			continue;
		}
		else
		{
			// if the user has already answered this question
			if(isset($exerciseResult[$questionId])) {
				// construction of the Question object
				$objQuestionTmp=new Question();

				// reads question informations
				$objQuestionTmp->read($questionId);

				$questionName=$objQuestionTmp->selectTitle();

				// destruction of the Question object
				unset($objQuestionTmp);
				echo "<table width=96%>";
				echo '<tr><td>'.$langAlreadyAnswered.' &quot;'.$questionName.'&quot;</td></tr>';
				echo "</table>";
				break;
			}
		}
	//echo "</table>\n";
	}
?>

	<table width="96%" align=center cellpadding="0" cellspacing="0" border="0" style="border: 1px solid <? echo "$table_border"; ?>;">
	<tr>
	  <th valign="top" colspan="2" align=left class=td_QuestionHeader  style="border: 1px solid white;"><b>
		<?= $langQuestion; ?> <?php echo $i; if($exerciseType == 2) echo ' / '.$nbrQuestions; ?></b>:
	  </th>
	</tr>

<?
	// shows the question and its answers
	showQuestion($questionId);
?>
	<tr>
          <td class="td_QuestionBody" valign="top" colspan="2" align=left>&nbsp;</td>
        </tr>
<?
	// for sequential exercises
	if($exerciseType == 2)
	{
		// quits the loop
		break;
	}

	echo "</table>\n";
	echo "<br>\n";
	echo "<table border=\"0\" align='center' width=\"96%\" style=\"border: 1px solid $table_border;\" cellspacing=\"0\" cellpadding=\"0\">\n";
}	// end foreach()
?>
     
     <table width="96%" align=center cellpadding="0" cellspacing="0" border="0">
     <tr>
        <td align="center" valign=middle>
<?
	if (!isset($questionId))
	 {
	 	echo "       !<br><br>";
		echo "<input type=\"submit\" class=\"buttonSubmit\" name=\"buttonCancel\" value=\"$langCancel\">
        </td>
     </tr>
     </table>
   </form>";
	 }
	 else
	 {
	 ?>
       <input type="submit" class="buttonSubmit"  value=<? echo ($exerciseType == 1 || $nbrQuestions == $questionNum)?$langOk:$langNext.' &gt;'; ?> >
 &nbsp;&nbsp;
 
 		<input type="submit" class="buttonSubmit" name="buttonCancel" value=<?= $langCancel; ?>>
	
        </td>
     </tr>
     </table>
   </form>
   <?
   }



echo "</td>\n";
echo "</tr>\n";
echo "</table>\n";

end_page();
?>
