<?php 
/*
      +----------------------------------------------------------------------+
      | GUnet eClass 1.7                                                    |
      | Asychronous Teleteaching Platform                                    |
      +----------------------------------------------------------------------+
      | Copyright (c) 2003-2007  GUnet                                       |
      +----------------------------------------------------------------------+
      |                                                                      |
      | GUnet eClass 1.7 is an open platform distributed in the hope that   |
      | it will be useful (without any warranty), under the terms of the     |
      | GNU License (General Public License) as published by the Free        |
      | Software Foundation. The full license can be read in "license.txt".  |
      |                                                                      |
      | Main Developers Group: Costas Tsibanis <k.tsibanis@noc.uoa.gr>       |
      |                        Yannis Exidaridis <jexi@noc.uoa.gr>           |
      |                        Alexandros Diamantidis <adia@noc.uoa.gr>      |
      |                        Tilemachos Raptis <traptis@noc.uoa.gr>        |
      |                                                                      |
      | For a full list of contributors, see "credits.txt".                  |
      |                                                                      |
      +----------------------------------------------------------------------+
      | Contact address: Asynchronous Teleteaching Group (eclass@gunet.gr),  |
      |                  Network Operations Center, University of Athens,    |
      |                  Panepistimiopolis Ilissia, 15784, Athens, Greece    |
      +----------------------------------------------------------------------+
*/
// ALLOWED_TO_INCLUDE is defined in admin.php
if(!defined('ALLOWED_TO_INCLUDE'))
{
	exit();
}

// the exercise form has been submitted
if(isset($submitExercise))
{
	$exerciseTitle=trim($exerciseTitle);
	$exerciseDescription=trim($exerciseDescription);
	@$randomQuestions=$randomQuestions?$questionDrawn:0;

	// no title given
	if(empty($exerciseTitle))
	{
		$msgErr=$langGiveExerciseName;
	}
	else
	{
		$objExercise->updateTitle($exerciseTitle);
		$objExercise->updateDescription($exerciseDescription);
		$objExercise->updateType($exerciseType);
		$objExercise->setRandom($randomQuestions);
		$objExercise->save();

		// reads the exercise ID (only usefull for a new exercise)
		$exerciseId=$objExercise->selectId();

		unset($modifyExercise);
	}
}
else
{
	$exerciseTitle=$objExercise->selectTitle();
	$exerciseDescription=$objExercise->selectDescription();
	$exerciseType=$objExercise->selectType();
	$randomQuestions=$objExercise->isRandom();
}

// shows the form to modify the exercise
if(isset($modifyExercise))
{

?>
   <FIELDSET style="PADDING-RIGHT: 7px; PADDING-LEFT: 7px; PADDING-BOTTOM: 7px; PADDING-TOP: 7px">
   <LEGEND>
   <? if(isset($mod))
      {
	echo "$langModExercise</LEGEND>";
      }
      else
      {
	echo "$langNewExercise</LEGEND>";
      }
   ?>
   <form method="post" action="<?php echo $PHP_SELF; ?>?modifyExercise=<?php echo $modifyExercise; ?>">
   <table align="center" border="0" width=96%>
<?php

	if(!empty($msgErr))
	{
?>
    <tr>
      <td colspan="2" class="alert1">
      <?php echo $msgErr; ?>
      </td>
    </tr>
    <tr>
      <td colspan="2">&nbsp;</td>
    </tr>

<?php
	}
?>

   <tr>
     <td><?php echo $langExerciseName; ?> :</td>
     <td><input type="text" class="auth_input" name="exerciseTitle" size="50" maxlength="200" value="<?php echo htmlspecialchars($exerciseTitle); ?>" style="width:400px;"></td>
   </tr>
   <tr>
     <td valign="top"><?php echo $langExerciseDescription; ?> :</td>
     <td><textarea wrap="virtual" class="auth_input" name="exerciseDescription" cols="50" rows="4" style="width:400px;"><?php echo htmlspecialchars($exerciseDescription); ?></textarea></td>
   </tr>
   <tr>
     <td valign="top"><?php echo $langExerciseType; ?> :</td>
     <td><input type="radio" name="exerciseType" value="1" <?php if($exerciseType <= 1) echo 'checked="checked"'; ?>> <?php echo $langSimpleExercise; ?><br>
         <input type="radio" name="exerciseType" value="2" <?php if($exerciseType >= 2) echo 'checked="checked"'; ?>> <?php echo $langSequentialExercise; ?></td>
   </tr>
<?php
	if($exerciseId && $nbrQuestions)
	{
?>
   <tr>
     <td valign="top"><?php echo $langRandomQuestions; ?> :</td>
     <td><input type="checkbox" name="randomQuestions" value="1" <?php if($randomQuestions) echo 'checked="checked"'; ?>> <?php echo $langYes; ?>, <?php echo $langTake; ?>
         <select name="questionDrawn">
<?php
		for($i=1;$i <= $nbrQuestions;$i++)
		{
?>
	 <option value="<?php echo $i; ?>" <?php if((isset($formSent) && $questionDrawn == $i) || (!isset($formSent) && ($randomQuestions == $i || ($randomQuestions <= 0 && $i == $nbrQuestions)))) echo 'selected="selected"'; ?>><?php echo $i; ?></option>

<?php
		}
?>
	</select> <?php echo strtolower($langQuestions).' '.$langAmong.' '.$nbrQuestions; ?>
      </td>
   </tr>

<?php
	}
?>

   <tr>
     <td>&nbsp;</td>
     <td colspan="1" align="left">
	<input type="submit" class="buttonSubmit" name="submitExercise" value="<?php echo $langOk; ?>">
	&nbsp;&nbsp;<input type="submit" class="buttonSubmit" name="cancelExercise" value="<?php echo $langCancel; ?>">
     </td>
   </tr>

   </table>
   </form>
   </FIELDSET>
<?php
}
else
{
?>
   <!-- Next Step from submit New Exercise -->
   <table border="0" align="center" width="96%" style="border: 1px solid <? echo "$table_border"; ?>;" cellspacing="0" cellpadding="0">
   <tr>
      <td class=td_QuestionHeader height=30 valign=middle align=center>
	<b><?= $langManagementProperties ?></b>
      </td>
   </tr>
   <tr>
      <td class=td_QuestionHeader valign=middle align=left>
        <b><?php echo $exerciseTitle; ?></b><a href="<?php echo $PHP_SELF; ?>?modifyExercise=yes&mod=1"><img src="../../images/edit.gif" style="border: 0; vertical-align: middle;" alt="<?php echo $langModify; ?>"></a>
      </td>
   </tr>
   <tr>
      <td class=td_QuestionHeader valign=middle align=left>
	<?
   	if(!$exerciseDescription) {
     		echo "    ";
   	}
  	else
   	{
     		echo nl2br($exerciseDescription);
   	}
   	?>
      </td>
   </tr>
   </table>

   <br>
<?php
}
?>
