<?php
/*
      +----------------------------------------------------------------------+
      | GUnet eClass 1.7                                                    |
      | Asychronous Teleteaching Platform                                    |
      +----------------------------------------------------------------------+
      | Copyright (c) 2003-2007  GUnet                                       |
      +----------------------------------------------------------------------+
      |                                                                      |
      | GUnet eClass 1.7 is an open platform distributed in the hope that   |
      | it will be useful (without any warranty), under the terms of the     |
      | GNU License (General Public License) as published by the Free        |
      | Software Foundation. The full license can be read in "license.txt".  |
      |                                                                      |
      | Main Developers Group: Costas Tsibanis <k.tsibanis@noc.uoa.gr>       |
      |                        Yannis Exidaridis <jexi@noc.uoa.gr>           |
      |                        Alexandros Diamantidis <adia@noc.uoa.gr>      |
      |                        Tilemachos Raptis <traptis@noc.uoa.gr>        |
      |                                                                      |
      | For a full list of contributors, see "credits.txt".                  |
      |                                                                      |
      +----------------------------------------------------------------------+
      | Contact address: Asynchronous Teleteaching Group (eclass@gunet.gr),  |
      |                  Network Operations Center, University of Athens,    |
      |                  Panepistimiopolis Ilissia, 15784, Athens, Greece    |
      +----------------------------------------------------------------------+
*/
include('exercise.class.php');
include('question.class.php');
include('answer.class.php');

session_start();

// answer types
define('UNIQUE_ANSWER',	1);
define('MULTIPLE_ANSWER', 2);
define('FILL_IN_BLANKS', 3);
define('MATCHING', 4);

$require_current_course = TRUE;
$langFiles='exercice';
include '../../include/init.php';

$nameTools = $langExercices;
$navigation[]= array ("url"=>"exercice.php", "name"=> $langExercices);

begin_page($nameTools);

// latex support
include_once '../../modules/latexrender/latex.php';

echo "<table align=center height=316 width=100% border=\"0\" cellpadding=\"0\" cellspacing=\"0\">\n";
echo "<tr>\n";
echo "<td valign=top>\n";


include('../../include/lib/textLib.inc.php');

$TBL_EXERCICE_QUESTION='exercice_question';
$TBL_EXERCICES='exercices';
$TBL_QUESTIONS='questions';
$TBL_REPONSES='reponses';

// if the above variables are empty or incorrect, stops the script
if(!is_array($exerciseResult) || !is_array($questionList) || !is_object($objExercise))
{
	die($langExerciseNotFound);
}

$exerciseTitle=$objExercise->selectTitle();

?>

   <table border="0" align='center' width="96%" style="border: 1px solid <? echo "$table_border"; ?>;" cellspacing=\"0\" cellpadding=\"0\">
   <tr>
      <td class='td_QuestionHeader'><b><?php echo stripslashes($exerciseTitle).': '; ?></b><?php echo $langResult; ?></td>
   </tr>
   </table>
   <br>


<form method="get" action="exercice.php">

<?php
	$i=$totalScore=$totalWeighting=0;

	// for each question
	foreach($questionList as $questionId)
	{
		// gets the student choice for this question
		$choice=@$exerciseResult[$questionId];

		// creates a temporary Question object
		$objQuestionTmp=new Question();

		$objQuestionTmp->read($questionId);

		$questionName=$objQuestionTmp->selectTitle();
		// latex support
		$questionName=latex_content($questionName);
		$questionWeighting=$objQuestionTmp->selectWeighting();
		$answerType=$objQuestionTmp->selectType();

		// destruction of the Question object
		unset($objQuestionTmp);

		if($answerType == UNIQUE_ANSWER || $answerType == MULTIPLE_ANSWER)
		{
			$colspan=4;
		}
		elseif($answerType == MATCHING)
		{
			$colspan=2;
		}
		else
		{
			$colspan=1;
		}
?>

<table width="96%" align='center' border="0" cellpadding="0" cellspacing="1" style="border: 1px solid <? echo "$table_border"; ?>;">
<tr>
  <td colspan="<?php echo $colspan; ?>" align=left class='td_QuestionHeader'><b>
	<?php echo $langQuestion.' '.($i+1); ?></b>
        <br>
        <?
        if ($questionName) {
           echo $questionName; 
        }
        ?>
  </td>
</tr>

<tr>
  <td colspan="<?php echo $colspan; ?>" align=left>&nbsp;
  </td>
</tr>

<tr>
  <td colspan="<?php echo $colspan; ?>" align=left>&nbsp;
  <table width=97% align=center style="border: 1px solid <? echo "$table_border"; ?>;" border="0" cellpadding="0" cellspacing="1">
<?
		if($answerType == UNIQUE_ANSWER || $answerType == MULTIPLE_ANSWER)
		{
?>
<tr>
  <td class='td_QuestionBody' width="10%" valign="middle" align="center">
	<small><i><?php echo $langChoice; ?></i></small>
  </td>
  <td class='td_QuestionBody' width="10%" valign="middle" align="center">
	<small><i><?php echo $langExpectedChoice; ?></i></small>
  </td>
  <td class='td_QuestionBody' width="40%" valign="middle" align="center">
	<small><i><?php echo $langAnswer; ?></i></small>
  </td>
  <td class='td_QuestionBody' width="40%" valign="middle" align="center">
	<small><i><?php echo $langComment; ?></i></small>
  </td>
</tr>
<?
	}
	elseif($answerType == FILL_IN_BLANKS)
	{
?>

<tr>
  <td class='td_QuestionBody' valign="middle" align="center">
	<small><i><?= $langAnswer; ?></i></small>
  </td>
</tr>

<?
	} else {
?>

<tr>
  <td class='td_QuestionBody' width="50%" valign="middle" align="center">
	<small><i><?= $langElementList; ?></i></small>
  </td>
  <td class='td_QuestionBody' width="50%" valign="middle" align="center">
	<small><i><?= $langCorrespondsTo; ?></i></small>
  </td>
</tr>

<?
		}

		// construction of the Answer object
		$objAnswerTmp=new Answer($questionId);

		$nbrAnswers=$objAnswerTmp->selectNbrAnswers();

		$questionScore=0;

		for($answerId=1;$answerId <= $nbrAnswers;$answerId++)
		{
			$answer=$objAnswerTmp->selectAnswer($answerId);
			$answerComment=$objAnswerTmp->selectComment($answerId);
			$answerCorrect=$objAnswerTmp->isCorrect($answerId);
			$answerWeighting=$objAnswerTmp->selectWeighting($answerId);
			$answer=latex_content($answer);

			switch($answerType)
			{
				// for unique answer
				case UNIQUE_ANSWER :	$studentChoice=($choice == $answerId)?1:0;

										if($studentChoice)
										{
										  	$questionScore+=$answerWeighting;
											$totalScore+=$answerWeighting;
										}

										break;
				// for multiple answers
				case MULTIPLE_ANSWER :	$studentChoice=@$choice[$answerId];

										if($studentChoice)
										{
											$questionScore+=$answerWeighting;
											$totalScore+=$answerWeighting;
										}

										break;
				// for fill in the blanks
				case FILL_IN_BLANKS :	// splits text and weightings that are joined with the character '::'
										list($answer,$answerWeighting)=explode('::',$answer);

										// splits weightings that are joined with a comma
										$answerWeighting=explode(',',$answerWeighting);

										// we save the answer because it will be modified
										$temp=$answer;

										$answer='';

										$j=0;

										// the loop will stop at the end of the text
										while(1)
										{
											// quits the loop if there are no more blanks
											if(($pos = strpos($temp,'[')) === false)
											{
												// adds the end of the text
												$answer.=$temp;
												break;
											}

											// adds the piece of text that is before the blank and ended by [
											$answer.=substr($temp,0,$pos+1);

											$temp=substr($temp,$pos+1);

											// quits the loop if there are no more blanks
											if(($pos = strpos($temp,']')) === false)
											{
												// adds the end of the text
												$answer.=$temp;
												break;
											}

											$choice[$j]=trim(stripslashes($choice[$j]));

											// if the word entered by the student IS the same as the one defined by the professor
											if(strtolower(substr($temp,0,$pos)) == strtolower($choice[$j]))
											{
												// gives the related weighting to the student
												$questionScore+=$answerWeighting[$j];

												// increments total score
												$totalScore+=$answerWeighting[$j];

												// adds the word in green at the end of the string
												$answer.=$choice[$j];
											}
											// else if the word entered by the student IS NOT the same as the one defined by the professor
											elseif(!empty($choice[$j]))
											{
												// adds the word in red at the end of the string, and strikes it
												$answer.='<font color="red"><s>'.$choice[$j].'</s></font>';
											}
											else
											{
												// adds a tabulation if no word has been typed by the student
												$answer.='&nbsp;&nbsp;&nbsp;';
											}

											// adds the correct word, followed by ] to close the blank
											$answer.=' / <font color="green"><b>'.substr($temp,0,$pos).'</b></font>]';

											$j++;

											$temp=substr($temp,$pos+1);
										}

										break;
				// for matching
				case MATCHING :			if($answerCorrect)
										{
											if($answerCorrect == $choice[$answerId])
											{
												$questionScore+=$answerWeighting;
												$totalScore+=$answerWeighting;
												$choice[$answerId]=$matching[$choice[$answerId]];
											}
											elseif(!$choice[$answerId])
											{
												$choice[$answerId]='&nbsp;&nbsp;&nbsp;';
											}
											else
											{
												$choice[$answerId]='<font color="red"><s>'.$matching[$choice[$answerId]].'</s></font>';
											}
										}
										else
										{
											$matching[$answerId]=$answer;
										}
										break;
			}	// end switch()

			if($answerType != MATCHING || $answerCorrect)
			{
				if($answerType == UNIQUE_ANSWER || $answerType == MULTIPLE_ANSWER)
				{
?>

<tr>
  <td width="5%" align="center" class='td_QuestionBody'>
	<img src="../../images/<?php echo ($answerType == UNIQUE_ANSWER)?'radio':'checkbox'; echo $studentChoice?'_on':'_off'; ?>.gif" border="0">
  </td>
  <td width="5%" align="center" class='td_QuestionBody'>
	<img src="../../images/<?php echo ($answerType == UNIQUE_ANSWER)?'radio':'checkbox'; echo $answerCorrect?'_on':'_off'; ?>.gif" border="0">
  </td>
  <td width="45%" class='td_QuestionBody'>
	<?php echo $answer; ?>
  </td>
  <td width="45%" class='td_QuestionBody'>
	<?php if($studentChoice) echo nl2br(make_clickable($answerComment)); else echo '&nbsp;'; ?>
  </td>
</tr>

<?
	} elseif($answerType == FILL_IN_BLANKS) {
?>

<tr>
  <td class='td_QuestionBody'>
	<?php echo nl2br($answer); ?>
  </td>
</tr>

<?
	} else {
?>

<tr>
  <td class='td_QuestionBody' width="50%">
	<?= $answer; ?>
  </td>
  <td width="50%" class='td_QuestionBody'>
	<? echo $choice[$answerId]; ?> / <font color="green"><b><?php echo $matching[$answerCorrect]; ?></b></font>
  </td>
</tr>

<?
		}
	}
}	// end for()
?>

</table>
<tr>
  <td colspan="<?= $colspan; ?>" align="right">&nbsp;</td>
</tr>
<tr>
  <td colspan="<?= $colspan; ?>" align="right">
	<b><?php echo "$langScore : $questionScore/$questionWeighting"; ?></b>&nbsp;&nbsp;
  </td>
</tr>
</table>
<br>

<?
		// destruction of Answer
		unset($objAnswerTmp);

		$i++;

		$totalWeighting+=$questionWeighting;
	}	// end foreach()
?>

<table width="96%" align="center" border="0" cellpadding="0" cellspacing="0">
<tr>
  <td align="center" class="td_QuestionHeader" height=30 valign=middle style="border: 1px solid <? echo "$table_border;" ?>;">
	<b><?php echo "$langYourTotalScore $totalScore/$totalWeighting"; ?> !</b>
  </td>
</tr>
<tr>
  <td align="center">
    <br>
	<input type="submit" class="buttonSubmit" value="<?= $langFinish; ?>">
  </td>
</tr>
</table>

</form>


<?
/*******************************/
/* Tracking of results         */
/*******************************/

// if tracking is enabled
if(isset($is_trackingEnabled))
{
	include($includePath.'/libs/events.lib.inc.php');

	event_exercice($objExercise->selectId(),$totalScore,$totalWeighting);
}


echo "</td>\n";
echo "</tr>\n";
echo "</table>\n";

end_page();
?>
